function Agencia() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Parametrização', 'Financeiro', 'Agência']);
	};

	this.selectBanco = (banco) => {
		geral.searchAndClickGridField('NMBANCO', banco);
		geral.clickAplicarFiltro();
	};

	this.adicionaAgencia = (codigo, agencia, cnpj, cep, telefone, fax) => {
		geral.clickAndFillField('CDAGENCIA', codigo);
		geral.clickAndFillField('NMAGENCIA', agencia);
		geral.clickAndFillField('NRCGCAGEN', cnpj);
		geral.clickAndFillField('NRCEPAGEN', cep);
		geral.fillField('NRFONEAGEN', telefone);
		geral.fillField('NRFAXAGEN', fax);
		geral.clickSalvar();
		protractorHelper.waitForElementVisibility(element(by.id('grid-1927843453876122292522')), 5000);
	};

	this.alteraAgencia = (agencia, cnpj, cep, telefone, fax) => {
		geral.clickEditar();
		geral.fillField('NMAGENCIA', agencia);
		geral.clickAndFillField('NRCGCAGEN', cnpj);
		geral.clickAndFillField('NRCEPAGEN', cep);
		geral.fillField('NRFONEAGEN', telefone);
		geral.clickAndFillField('NRFAXAGEN', fax);
		geral.clickSalvar();
	};

	this.adicionaContato = (nomePessoa, cargo, telefone) => {
		geral.trocarAba('Contato');
		protractorHelper.waitForElementVisibility(element(by.id('grid-19278434532905280706523')), 5000);
		geral.clickAdicionar();
		geral.fillField('NMCONTAGEN', nomePessoa);
		geral.fillField('DSCARGCOAGEN', cargo);
		geral.fillField('NRFONECOAGEN', telefone);
		geral.clickSalvar();
	};

	this.alteraContato = (cargo, telefone) => {
		geral.clickEditar();
		geral.fillField('DSCARGCOAGEN', cargo);
		geral.fillField('NRFONECOAGEN', telefone);
		geral.clickSalvar();
	};
}

module.exports = new Agencia();
