const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../../json/leitorJson.po');
const tipoDeRecebimentoPage = require('../../../../page-objects/parametrizacao/financeiro/titulosAReceber/tipoDeRecebimento.po');
describe('Tipo de Recebimento', () => {
    beforeAll(() => {
        loginPage.site();
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        tipoDeRecebimentoPage.abrir();
    });

    afterAll(() => {
        geral.sair();
    });

    it('Acessar tela de Tipo de Recebimento', () => {
        expect(z.component.header.getTitle()).toBe('Tipo de Recebimento');
    });

    it('Realizar o preenchimento dos campos solicitados na página', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-1351987903839340006283')));
        geral.clickAdicionar();
        tipoDeRecebimentoPage.adicionar(j.getValor('codigoRecebimento'), j.getValor('nomeTipoRecebimento'),
            j.getValor('tipoDeRecebimento'), j.getValor('ordemParaTroco'), j.getValor('tipoTroco'),
            j.getValor('descricaoRecebimento'), j.getValor('emiteVale'), j.getValor('debitoConta'),
            j.getValor('taxaAdministrativa'), j.getValor('valorMinimo'), j.getValor('diasParaRecebimento'),
            j.getValor('codigoCredenciadoraCartao'), j.getValor('codigoBandeiraTef'),
            j.getValor('codigoCnpjAdministradoraTicket'), j.getValor('codigoBandeiraSefaz'),
            j.getValor('solicitaQuantidadeParcela'), j.getValor('quantidadeMaximaParcela'),
            j.getValor('valorMinimoParcela'), j.getValor('tipoRecebimentoTrocaMercadoria'),
            j.getValor('sangriaFechamentoCaixa'), j.getValor('manutencaoLancamentoSangria'),
            j.getValor('manutencaoLancamentoEntradaSaida'), j.getValor('solicitaVendasCreditoDebito'),
            j.getValor('utilizaCartaoVoucher'), j.getValor('habilitaVendaGerencial'), j.getValor('abreGaveta'),
            j.getValor('controlaRepique'));
        geral.clickSalvar();
        expect(geral.gridHasText('1351987903839340006283', j.getValor('nomeTipoRecebimento'), 1)).toEqual('MASTERCARD INTER');
    });

        it('Editar Registro', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-1351987903839340006283')));
        geral.filterIt(j.getValor('nomeTipoRecebimento'));
        geral.clickGrid('NMTIPORECE', j.getValor('nomeTipoRecebimento'), '1351987903839340006283');
        geral.clickEditar();
        tipoDeRecebimentoPage.editar(j.getValor('nomeTipoRecebimento1'), j.getValor('tipoDeRecebimento1'),
        j.getValor('ordemParaTroco1'), j.getValor('tipoTroco1'), j.getValor('descricaoRecebimento1'),
        j.getValor('emiteVale1'), j.getValor('debitoConta1'), j.getValor('taxaAdministrativa1'),
        j.getValor('valorMinimo1'), j.getValor('diasParaRecebimento1'), j.getValor('solicitaQuantidadeParcela1'),
        j.getValor('tipoRecebimentoTrocaMercadoria1'), j.getValor('sangriaFechamentoCaixa1'),
        j.getValor('manutencaoLancamentoSangria1'), j.getValor('manutencaoLancamentoEntradaSaida1'),
        j.getValor('habilitaVendaGerencial1'), j.getValor('abreGaveta1'), j.getValor('controlaRepique1'));
        geral.clickSalvar();
        geral.clickVoltar();
        geral.filterIt(j.getValor('nomeTipoRecebimento1'));
        expect(geral.gridHasText('1351987903839340006283', j.getValor('nomeTipoRecebimento1'), 1)).toEqual('DEBITO MASTER');
    });
    it('Excluir Registro', () => {
        protractorHelper.waitForElementVisibility(element(by.id('grid-1351987903839340006283')));
        geral.clickGrid('NMTIPORECE', j.getValor('nomeTipoRecebimento1'), '1351987903839340006283');
        geral.clickExcluir();
        geral.clickSim();
        geral.filterIt(j.getValor('nomeTipoRecebimento1'));
        expect(geral.gridHasText('1351987903839340006283', j.getValor('nomeTipoRecebimento1'), 1));
    }
    );
});
